zonelist.c File Reference
`#include "config.h"`
`#include "parser/confparser.h"`
`#include "parser/zonelistparser.h"`
`#include "duration.h"`
`#include "file.h"`
`#include "log.h"`
`#include "status.h"`
`#include "signer/zone.h"`
`#include "signer/zonelist.h"`
`#include <ldns/ldns.h>`
`#include <stdlib.h>`

Go to the source code of this file.

## Functions

zonelist_type * | zonelist_create ()
zone_type * | zonelist_lookup_zone_by_name (zonelist_type *zonelist, const char *name, ldns_rr_class klass)
zone_type * | zonelist_lookup_zone_by_dname (zonelist_type *zonelist, ldns_rdf *dname, ldns_rr_class klass)
zone_type * | zonelist_add_zone (zonelist_type *zlist, zone_type *zone)
void | zonelist_del_zone (zonelist_type *zlist, zone_type *zone)
ods_status | zonelist_update (zonelist_type *zl, const char *zlfile)
void | zonelist_cleanup (zonelist_type *zl)
void | zonelist_free (zonelist_type *zl)

## Function Documentation

## zonelist_add_zone()

zone_type * zonelist_add_zone | ( | zonelist_type * | zlist,
|  | zone_type * | zone
| ) |  |

Add zone.

Definition at line 201 of file zonelist.c.

References zonelist_struct::just_added, zone_struct::name, zone_struct::zl_status, zone_cleanup(), ZONE_ZL_ADDED, and zonelist_struct::zones.

Referenced by parse_zonelist_zones().

## zonelist_cleanup()

void zonelist_cleanup | ( | zonelist_type * | zl | ) |

Clean up a zonelist.

Definition at line 432 of file zonelist.c.

References zonelist_struct::zl_lock, and zonelist_struct::zones.

Referenced by engine_cleanup().

## zonelist_create()

zonelist_type * zonelist_create | ( | void |  | ) |

Create a new zone list.

Definition at line 74 of file zonelist.c.

References zonelist_struct::last_modified, zonelist_struct::zl_lock, and zonelist_struct::zones.

Referenced by zonelist_update().

## zonelist_del_zone()

void zonelist_del_zone | ( | zonelist_type * | zlist,
|  | zone_type * | zone
| ) |  |

Delete zone.

Definition at line 238 of file zonelist.c.

References zone_struct::name, and zonelist_struct::zones.

Referenced by engine_update_zones().

## zonelist_free()

void zonelist_free | ( | zonelist_type * | zl | ) |

Free zonelist.

Definition at line 453 of file zonelist.c.

References zonelist_struct::zl_lock, and zonelist_struct::zones.

Referenced by zonelist_update().

## zonelist_lookup_zone_by_dname()

zone_type * zonelist_lookup_zone_by_dname | ( | zonelist_type * | zonelist,
|  | ldns_rdf * | dname,
|  | ldns_rr_class | klass
| ) |  |

Lookup zone by dname.

Definition at line 182 of file zonelist.c.

References zonelist_lookup_zone_by_name(), and zonelist_struct::zones.

Referenced by query_process().

## zonelist_lookup_zone_by_name()

zone_type * zonelist_lookup_zone_by_name | ( | zonelist_type * | zonelist,
|  | const char * | name,
|  | ldns_rr_class | klass
| ) |  |

Lookup zone by name.

Definition at line 157 of file zonelist.c.

References zone_cleanup(), zone_create(), and zonelist_struct::zones.

Referenced by zonelist_lookup_zone_by_dname().

## zonelist_update()

ods_status zonelist_update | ( | zonelist_type * | zl,
|  | const char * | zlfile
| ) |  |

Update zone list.

Definition at line 342 of file zonelist.c.

References zonelist_struct::just_added, zonelist_struct::just_removed, zonelist_struct::just_updated, zonelist_struct::last_modified, zonelist_create(), zonelist_free(), and zonelist_struct::zones.

Referenced by engine_start().